﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

using Marlboro.Web.Entities;
using Marlboro.Web.Extension;

namespace Marlboro.Web.Controllers
{
    public class CityController : Controller
    {
        //
        // GET: /City/

        public ActionResult Index()
        {
            return View();
        }


        /// <summary>
        /// 返回绑定的DROPDOWNLIST数据
        /// </summary>
        /// <returns></returns>
        public ActionResult Citylist()
        {
            ViewData["ProvinceList"] = new Marlboro.Web.Models.CityModels().GetDropdownlistItem();
            return View();
        }
        /// <summary>
        /// 通过省的ID 取出所有城市的JSON格式
        /// </summary>
        /// <param name="provinceId"></param>
        /// <returns></returns>
        public JsonResult Getlist(int? provinceId)
        {
            List<City> Citylist = new Marlboro.Web.Models.CityModels().Citylist(provinceId);
            var retVal = new Extension.BuildJson<City, int>(
                Citylist,
                city => city.City_ID,
                city => "",
                city => city.City_ID.ToString(),
                city => city.City_Code,
                city => city.City_Name,
                city => city.province_ID.ToString()
                ).Build();
            return Json(retVal, JsonRequestBehavior.AllowGet);
        }




        [HttpPost]
        public ActionResult Edit(long id, FormCollection collection)
        {

            try
            {
                //[0000055] bug fix
                string CityID = collection["CityID"];
                string code = collection["CityCode"];
                string name = collection["CityName"];
                string Provinceid = collection["ProvinceID"];

                if (string.IsNullOrEmpty(code))
                {
                    return this.Content("City code is required!");  
                }
              
                if (string.IsNullOrEmpty(name))
                {
                    return this.Content("City name is required!");
                }
                City c = new Marlboro.Web.Models.CityModels().GetCitylistByID(Convert.ToInt32(CityID));
                if (c == null)
                {
                    return this.Content("The city to be update has been deleted by another user.");
                }
               
                c.City_ID = Convert.ToInt32(CityID);
                c.City_Code = code;
                c.City_Name = name;
                c.province_ID = Convert.ToInt32(Provinceid);

                new Marlboro.Web.Models.CityModels().UpdateCityByID(c);
            }
            catch (Exception ex)
            {
                //this.Response.Headers["exceptionMessage"] = ex.Message;
                //throw ex;
                return this.Content(ex.Message);
            }
            return this.Content("");
        }

    }
}
