﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Globalization;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using System.Data;
using System.Collections;

using Marlboro.Web.Entities;

namespace Marlboro.Web.Models
{
    public class CityModels
    {

        /// <summary>
        /// 获取所有省信息 绑定Dropdownlist
        /// </summary>
        /// <returns></returns>
        public List<SelectListItem> GetDropdownlistItem()
        {
            List<SelectListItem> list = new List<SelectListItem>();
            DataTable Itemsdt = new DataTable();
            Itemsdt = new DataBaseTest.OracleHelper().ExecuteDataTable("select * from PROVINCE");
            if (Itemsdt.Rows.Count != 0)
            {
                for (int i = 0; i < Itemsdt.Rows.Count; i++)
                {
                    list.Add(new SelectListItem { Text = Itemsdt.Rows[i]["ProvinceName"].ToString(), Value = Itemsdt.Rows[i]["ProvinceID"].ToString() });
                }
            }
            return list ?? null;
        }

        /// <summary>
        /// 通过procinveId 获取City列表
        /// </summary>
        /// <param name="provinceId"></param>
        /// <returns></returns>
        public List<City> Citylist(int? provinceId)
        {

            List<City> Citylist = new List<City>();
            DataTable dt = new DataTable();
            dt = new DataBaseTest.OracleHelper().ExecuteDataTable("select * from City where ProcinceID='" + provinceId + "'");//where ProcinceID='" + provinceID + "'
            if (dt.Rows.Count != 0)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    City city = new City();
                    city.City_ID = Convert.ToInt32(dt.Rows[i]["CITYID"]);
                    city.City_Code = dt.Rows[i]["CITYCODE"].ToString();
                    city.City_Name = dt.Rows[i]["CITYNAME"].ToString();
                    city.province_ID = Convert.ToInt32(dt.Rows[i]["PROCINCEID"]);
                    Citylist.Add(city);
                }
            }
            return Citylist;
        }


        /// <summary>
        /// 通过CityID 获取实体
        /// </summary>
        /// <param name="CityID"></param>
        /// <returns></returns>
        public City GetCitylistByID(int? CityID)
        {
            City city = new City();
            DataTable dt = new DataTable();
            dt = new DataBaseTest.OracleHelper().ExecuteDataTable("select * from City where CITYID='" + CityID + "'");//where ProcinceID='" + provinceID + "'
            if (dt.Rows.Count != 0)
            {
                city.City_ID = Convert.ToInt32(dt.Rows[0]["CITYID"]);
                city.City_Code = dt.Rows[0]["CITYCODE"].ToString();
                city.City_Name = dt.Rows[0]["CITYNAME"].ToString();
                city.province_ID = Convert.ToInt32(dt.Rows[0]["PROCINCEID"]);
            }
            return city;
        }

        /// <summary>
        /// 更新City数据 提供给前台JS
        /// </summary>
        /// <param name="city"></param>
        public void UpdateCityByID(City city)
        {
            string sql = "update City set CITYCODE='" + city.City_Code + "',CITYNAME='" + city.City_Name + "',PROCINCEID='" + city.province_ID + "' where CITYID='" + city.City_ID + "'";
            new DataBaseTest.OracleHelper().ExcuteCity(sql);
        }
    }
}
