﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage<IEnumerable<Marlboro.Web.Models.CityModels>>" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
    Index
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
    <center>
        <%= Html.DropDownList("dplProvince", ViewData["ProvinceList"] as List<SelectListItem>)%></center>

    <script type="text/javascript">
        var JQGrid = function(provinceId) {
            $('#cityList').jqGrid({
                url: '<%= Url.Action("Getlist", "City") %>?provinceId=' + provinceId,
                datatype: 'json',
                colNames: ['Action', 'CityID', 'CityCode', 'CityName', 'ProvinceID',],
                colModel: [
                 { name: 'customZone', width: '200', sortable: false,align:'center' },
                   { name: 'CityID',index:'CityID', sortable: true,align:'center' },
                            { name: 'CityCode', index: 'CityCode', editable: true, sortable: true,align:'center'},
                            { name: 'CityName', index: 'CityName', editable: true, sortable: true,align:'center' },
                            { name: 'ProvinceID', index: 'ProvinceID', editable: true, sortable: true,align:'center' },
                ],
                rowNum: -1,
                caption: 'City List',
                viewrecords: true,
                autowidth: false,
                width:700,
                height: 'auto',
                gridComplete: function() {
                //传入行的ID 然后通过editBtn_id的事件来警醒editRow方法
                //从而实现了编辑状态
                    var editEvent = function(id) {
                        $('#editBtn_' + id).click(function() {
                            jQuery('#cityList').editRow(id);
                            return false;
                        });
                    }
                    //同理 获取code和name的值
                    //调用saveRow这个方法，方法中访问'<%=Url.Action("Edit","City") %>',CityController中的Edit方法来
                    //来进行保存的
                    var saveEvent = function(id) {
                        $('#saveBtn_' + id).click(function() {
                        
                            var code = $('#' + id + '_CityCode').val();
                            var name = $('#' + id + '_CityName').val();
                            if (code == '' || name == '') {
                                alert('City code/name is required!');
                            }
                            /*
                            else if (name.length > 10) {
                            alert('Hospital category name must be less than 10 characters!');
                            }*/
                            else {
                                jQuery('#cityList').saveRow(
                                    id,
                                    false,
                                    '<%=Url.Action("Edit","City") %>',
                                    null,
                                    function(id, xhr) {
                                        var msg = xhr.responseText;
                                        if (msg.length == 0) {
                                            alert("Saved successfully!");
                                        } else {
                                            jQuery('#cityList').editRow(id);
                                            alert("Failed because: " + msg);
                                        }
                                    },
                                    function(id, xhr) {
                                        var msg = xhr.getResponseHeader("exceptionMessage");
                                        alert(
                                            "Can not save data because of some unknown exception, HTTP status: " +
                                            xhr.status +
                                            ", server exception message: " +
                                            msg);
                                    });
                            }
                            return false;
                        });
                    }
                    var cancelEvent = function(id) {
                        $('#cancelBtn_' + id).click(function() {
                            jQuery('#cityList').restoreRow(id);
                            return false;
                        });
                    }
                    //最后把jQgrid中的每一行的事件注册上即可.
                    var ids = jQuery("#cityList").jqGrid('getDataIDs');
                    for (var i = 0; i < ids.length; i++) {
                        var cl = ids[i];
                        var editBtn = '<a href="javascript:void(0)" class="editBtn" title="Edit" id="editBtn_' + cl + '">Edit</a>';
                        var saveBtn = '<a href="javascript:void(0)" class="saveBtn" title="Save" id="saveBtn_' + cl + '">Save</a>';
                        var cancelBtn = '<a href="javascript:void(0)" class="cancelBtn" title="Cancel" id="cancelBtn_' + cl + '">Cancel</a>';

                        jQuery("#cityList").jqGrid('setRowData', ids[i], { customZone: editBtn + ' | ' + saveBtn + ' | ' + cancelBtn });
                        editEvent(cl);
                        saveEvent(cl);
                        cancelEvent(cl);
                    }
                }
            });
        };
        //这个功能在下一节实现.
        var CityCreate = function() {
            var provinceId = $('#dplProvince option:selected').val();
            if (provinceId == 0) {
                alert('Please select a province before creating new city.');
            }
            else {
                window.location.href = '<%= Url.Action("Create","City")%>/' + provinceId;
            }
        };
        
        $(function() {
            $('#dplProvince').find('option:first').attr('selected', true);

            JQGrid();
            $("#dplProvince").change(function(){
                var provinceId = $(this).val();
                $("#cityList").setGridParam(
                {
                    url: '<%= Url.Action("Getlist", "City") %>?provinceId=' + provinceId
                }
                ).trigger("reloadGrid");
            });
        });   
    </script>

    <div style="text-align: center">
        <%--显示主数据的Table ID为list--%>
        <table id="cityList">
        </table>
        <%--分页用的DIV ID为pager--%>
        <div id="pager">
        </div>
    </div>
</asp:Content>
